/* global wc_stripe_params */

jQuery( function( $ ) {
  setTimeout(function() {
    $('#waave_guest_credit_card-card-number').parent().addClass('validate-required');
    $('#waave_guest_credit_card-card-expiry').parent().addClass('validate-required');
    $('#waave_guest_credit_card-card-code').parent().addClass('validate-required');
    $('#waave_guest_credit_card-sms-code').parent().addClass('validate-required');
  }, 2000);

  // Get OTP
  const $checkout_form = $( 'form.checkout' );
  let flag = true;
  $checkout_form.on('click', '#sendCode', function() {
    const $phone_number_input = $( '#waave_guest_credit_card-phone-number' );
    const $phone_code = $( '#phoneCode' );
    const $parent = $phone_number_input.parent();

    if ( !flag ) {
      return false;
    }

    if ( !$phone_number_input.val() ) {
      $parent.addClass('woocommerce-invalid');
      return false;
    }

    $.ajax({
      url: $('#waaveUrl').val() + '/send-verification-code',
      method: 'POST',
      data: {
        sms_phone: $phone_code.val() + $phone_number_input.val()
      },
      beforeSend: function() {
        flag = false;
        $parent.removeClass('woocommerce-invalid');
        $('#errorSpan').hide();
        $('#successSpan').hide();
      },
      error: function(response) {
        $parent.addClass('woocommerce-invalid');
        $('#errorSpan').show().html(response.responseJSON.message);
      },
      success: function(data) {
        if (data.success) {
          $parent.removeClass('woocommerce-invalid');
          $('#successSpan').show().html(data.message);
        } else {
          $parent.addClass('woocommerce-invalid');
        }
      },
      complete: function() {
        flag = true;
        $('#sendCode').text('Resend');
      }
    });
  });

  // Verify OTP
  $checkout_form.on('keyup', '#waave_guest_credit_card-sms-code', function() {
    const $phone_number_input = $( '#waave_guest_credit_card-phone-number' );
    const $phone_code = $( '#phoneCode' );
    if (!$phone_number_input.val()) {
      return false;
    }

    if ($(this).val().length < 5) {
      return false;
    }

    $.ajax({
      url: $('#waaveUrl').val() + '/verify-verification-code',
      method: 'POST',
      data: {
        sms_code: $(this).val(),
        sms_phone: $phone_code.val() + $phone_number_input.val()
      },
      beforeSend: function() {
        $('#tkSpan').hide();
        $('#smsError').hide();
      },
      error: function(response) {
        $('#tkSpan').hide();
        $('#smsError').html(response.responseJSON.message).show();
      },
      success: function(data) {
        if (data.success) {
          $('#tkSpan').show();
        }
      }
    });
  });
} );