jQuery(function ($) {
  var vgsForm = null;
  jQuery(document.body).on("updated_checkout", function () {
    if (!$("#cc-number:has(iframe)").length) {
      vgsForm = window.VGSCollect.create(
        vgs_config.vault_id,
        vgs_config.env,
        () => {}
      );
      const css = {
        boxSizing: "border-box",
        fontFamily: '-apple-system, BlinkMacSystemFont, "Segoe UI"',
      };

      vgsForm.field("#cc-number", {
        type: "card-number",
        name: "card_number",
        successColor: "#4F8A10",
        errorColor: "#D8000C",
        placeholder: "Card number",
        showCardIcon: true,
        validations: ["required", "validCardNumber"],
        css: css,
      });

      vgsForm.field("#cc-cvc", {
        type: "card-security-code",
        name: "cvv",
        successColor: "#4F8A10",
        errorColor: "#D8000C",
        placeholder: "CVC",
        validations: ["required", "validCardSecurityCode"],
        css: css,
      });

      vgsForm.field("#cc-expiration-date", {
        type: "card-expiration-date",
        name: "card_exp",
        successColor: "#4F8A10",
        errorColor: "#D8000C",
        placeholder: "MM / YY",
        validations: ["required", "validCardExpirationDate"],
        css: css,
      });
    }
  });
  jQuery( document ).ready(function() {
    jQuery('form.checkout').on('checkout_place_order_waave_guest_credit_card', function() {
      if (jQuery('form.checkout').is('.waave-processing')) {
        jQuery('form.checkout').removeClass('waave-processing');
        return true;
      }

      $('#is_error_add_card').remove();
      $('#card-token').remove();
      $('#error_add_card_form').remove();
      $('#place_order').attr('disabled', true);

      vgsForm.submit(
        "/api/v1/cards/vgs",
        {},
        (status, response) => {
          if (status === 200) {
            $('<input>').attr({
              type: 'hidden',
              id: vgs_config.waave_form_id+'-card-token',
              name: vgs_config.waave_form_id+'-card-token',
              value: response.card_token,
            }).appendTo('form[name="checkout"]');
          } else {
            $('<input>').attr({
              type: 'hidden',
              id: 'is_error_add_card',
              name: 'is_error_add_card',
              value: true,
            }).appendTo('form[name="checkout"]');
          }
          jQuery('form[name="checkout"]').submit();
          jQuery('#place_order').attr('disabled', false);
        },
        (errors) => {
          let errorsMess = [];
          Object.keys(errors).forEach(function (key, index) {
            let errorEle = null;
            let errorFieldName = null;
            switch (key) {
              case "cvv":
                errorFieldName = "The CVC ";
                break;
              case "card_exp":
                errorFieldName = "The card expiration ";
                break;
              case "card_number":
                errorFieldName = "The card number ";
                break;
              default:
                errorField = key.replace('_', ' ');
                errorFieldName = errorField[0].toUpperCase() + errorField.slice(1) + ' ';   //capitalize first letter
            }
            errorEle = errors[key].errorMessages;
            errorEle.map(function (element) {
              errorsMess.push(errorFieldName + element + "</br>");
            });
          });
          $('<input>').attr({
            type: 'hidden',
            id: 'is_error_add_card',
            name: 'is_error_add_card',
            value: true,
          }).appendTo('form[name="checkout"]');
          $('<input>').attr({
            type: 'hidden',
            id: 'error_add_card_form',
            name: 'error_add_card_form',
            value: errorsMess.join(''),
          }).appendTo('form[name="checkout"]');
          jQuery('form[name="checkout"]').submit();
          jQuery('#place_order').attr('disabled', false);
        }
      );

      jQuery('form.checkout').addClass('waave-processing');
      return false;
    });
  });
});